=== doc/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})
set(DOXYFILE_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/doxygen")
set(DOXYFILE_HTML_DIR "${CMAKE_CURRENT_BINARY_DIR}/doxygen/html")
include(UseDoxygen)
