=== src/downloader/CMakeLists.txt ===
set(PRD_CONSOLETOOL OFF CACHE BOOL "disable console tool compile" FORCE)
set(PRD_SHAREDLIB OFF CACHE BOOL "disable shared lib compile" FORCE)
set(PRD_DEVELOP_FILES OFF CACHE BOOL "disable develop files" FORCE)
set(PRD_DO_INSTALL OFF CACHE BOOL "don't install any pr-downloader file" FORCE)
set(PRD_ARCHIVE_SUPPORT ON CACHE BOOL "disable archive support as it interferes with unitsync!" FORCE)
mark_as_advanced(FORCE CONSOLETOOL SHAREDLIB DEVELOP_FILES DO_INSTALL)

if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/lib/CMakeLists.txt")
	message(FATAL_ERROR "lib/CMakeLists.txt doesn't exist, please run \ngit submodule update --init")
else()
	set(ADD_WXCONVERT ON CACHE BOOL "" FORCE)
	set(LSLSERVER OFF CACHE BOOL "build lsl server" FORCE)
	set(PRD_TESTS OFF CACHE BOOL "build prd tests" FORCE)
	set(PRD_ENABLE_LSL ON CACHE BOOL "build lsl lib" FORCE)
	set(PRD_DEFAULT_LOGGER OFF CACHE BOOL "build defaukt logger" FORCE)
	add_definitions(-DHAVE_WX -DHAVE_SPRINGLOBBY)
	add_subdirectory(lib)
endif()
