=== debian/changelog ===
springlobby (0.274-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1115145)
  * Build depend on docbook-xml. (Closes: #1117915)

 -- Adrian Bunk <bunk@debian.org>  Fri, 17 Oct 2025 13:41:40 +0300

springlobby (0.274-1) unstable; urgency=medium

  * New upstream version 0.274.
  * Declare compliance with Debian Policy 4.6.2.

 -- Markus Koschany <apo@debian.org>  Mon, 23 Jan 2023 21:21:14 +0100
